VERSION 2.00
Begin Form FileControlForm 
   Caption         =   "File Controls"
   ClientHeight    =   5070
   ClientLeft      =   150
   ClientTop       =   975
   ClientWidth     =   2115
   ControlBox      =   0   'False
   Height          =   5475
   Icon            =   FILECONT.FRX:0000
   Left            =   90
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5070
   ScaleWidth      =   2115
   Top             =   630
   Width           =   2235
   Begin Frame FileControlFrame 
      Caption         =   "File Controls"
      Height          =   4935
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   1995
      Begin FileListBox FileControl 
         Height          =   1785
         Left            =   120
         TabIndex        =   4
         Top             =   2640
         Width           =   1755
      End
      Begin DirListBox DirControl 
         Height          =   1830
         Left            =   120
         TabIndex        =   3
         Top             =   720
         Width           =   1755
      End
      Begin DriveListBox DriveControl 
         Height          =   315
         Left            =   120
         TabIndex        =   2
         Top             =   300
         Width           =   1755
      End
      Begin ComboBox FilePatternCombo 
         Height          =   300
         Left            =   120
         TabIndex        =   1
         Text            =   "FilePatternCombo"
         Top             =   4500
         Width           =   1755
      End
   End
End
Option Explicit

Sub DirControl_Change ()
    FileControl.Path = DirControl.Path
End Sub

Sub DirControl_KeyDown (KeyCode As Integer, Shift As Integer)
    Select Case KeyCode

        Case ENTER_KEY
            Dim Selected As String
            Selected = DirControl.List(DirControl.ListIndex)
            DirControl.Path = Selected
            FileControl.Path = DirControl.Path

        Case DELETE_KEY
            Call DeleteSelectedDirectory

    End Select

End Sub

Sub DirControl_KeyPress (KeyAscii As Integer)
    Exit Sub
    If KeyAscii = ENTER_KEY Then
        Dim Selected As String
        Selected = DirControl.List(DirControl.ListIndex)
        DirControl.Path = Selected
        FileControl.Path = DirControl.Path
    End If

End Sub

Sub DriveControl_Change ()
    On Error GoTo DriveControlErrorHandler
    DirControl.Path = DriveControl.Drive
    
    Exit Sub

DriveControlErrorHandler:   ' Error handler line label.
    Dim msg As String
    Dim Drive As String
    Select Case Err
        Case 53: msg = "ERROR 53: That file doesn't exist."
        Case 68: msg = "ERROR 68: Drive " & Drive & ": not available."
        Case 76: msg = "ERROR 76: That path doesn't exist."
        Case Else: msg = "ERROR " & Err & " occurred." & NEW_LINE & Error(Err)
    End Select
    MsgBox msg, MB_ICONEXCLAMATION, "Error Changing Drive"  ' Display error message.
    Resume Next ' Resume procedure.

End Sub

Sub FileControl_DblClick ()
    Call OpenSelectedFile
    MainForm.SetFocus
End Sub

Sub FileControl_KeyDown (KeyCode As Integer, Shift As Integer)
    Select Case KeyCode

        Case ENTER_KEY
            Call OpenSelectedFile

        Case DELETE_KEY
            Call DeleteSelectedFile

    End Select

End Sub

Sub FilePatternCombo_Click ()
    FileControl.Pattern = FilePatternCombo.Text
End Sub

Sub FilePatternCombo_KeyUp (KeyCode As Integer, Shift As Integer)
    FileControl.Pattern = FilePatternCombo.Text
End Sub

Sub Form_Load ()
    FilePatternCombo.AddItem CBL_FILE_PATTERN
    FilePatternCombo.AddItem COB_FILE_PATTERN
    FilePatternCombo.AddItem CPY_FILE_PATTERN
    FilePatternCombo.AddItem BAT_FILE_PATTERN
    FilePatternCombo.AddItem TXT_FILE_PATTERN
    FilePatternCombo.AddItem ALL_FILES_PATTERN
    FilePatternCombo.Text = FilePatternCombo.List(0)

    FileControl.Pattern = DEFAULT_FILE_PATTERN

End Sub

Sub Form_Resize ()
    'change caption for when it's minimized.
    If FileControlForm.WindowState = WINDOW_STATE_MINIMIZED Then
        FileControlForm.Caption = "NE COBOL Editor File Controls"
    Else
        FileControlForm.Caption = "File Controls"
    End If
End Sub

Sub OpenSelectedFile ()
    Dim Selected As String
    Dim Path As String

    Selected = FileControl.List(FileControl.ListIndex)
    Path = FileControl.Path

    If Right$(Path, 1) <> "\" Then
        Path = Path + "\"
    End If

    If Not IsDiffFile%(Path, Selected) Then
        'Same file.. don't do anything.
        Exit Sub
    End If

    'check if file changed. If so, ask to save.
    Dim CurContents As String
    CurContents = MainForm.EditorText.Text
    If IsSaveReq%(CurContents) Then

        Dim DisplayFileName As String
        DisplayFileName = GetPreviousFileName$()
        
        Dim SaveChanges As Integer
        SaveChanges = MsgBox(GetPreviousFileName$() & " has been modified. Save changes?", MB_YESNO + MB_ICONQUESTION, "Save Changes?")
        If SaveChanges = IDYES Then
            If GetPreviousFileName$() <> NEW_FILE_STR Then
                Call SavePreviousFile(CurContents$)
            Else
                SaveFileForm.Visible = True
                MainForm.Enabled = False
                'Mainform will be re-enabled when save file form
                'is closed.
            End If
            Exit Sub
        End If
    End If
    
    MainForm.EditorText.Text = GetFileContents$(Path, Selected)
    MainForm.Caption = "NE COBOL Editor - " & Selected

End Sub

