VERSION 2.00
Begin Form OpenFileForm 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Open File"
   ClientHeight    =   3150
   ClientLeft      =   3990
   ClientTop       =   3465
   ClientWidth     =   5160
   Height          =   3555
   Left            =   3930
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3150
   ScaleWidth      =   5160
   Top             =   3120
   Width           =   5280
   Begin DirListBox DirControl 
      Height          =   1605
      Left            =   1800
      TabIndex        =   6
      Top             =   780
      Width           =   1935
   End
   Begin DriveListBox DriveControl 
      Height          =   315
      Left            =   1800
      TabIndex        =   5
      Top             =   2760
      Width           =   1935
   End
   Begin FileListBox FileControl 
      Height          =   1590
      Left            =   60
      TabIndex        =   4
      Top             =   780
      Width           =   1695
   End
   Begin CommandButton OkCommand 
      Caption         =   "&OK"
      Height          =   315
      Left            =   3780
      TabIndex        =   3
      Top             =   60
      Width           =   1335
   End
   Begin CommandButton CancelCommand 
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   3780
      TabIndex        =   2
      Top             =   480
      Width           =   1335
   End
   Begin ComboBox FileExtensionCombo 
      Height          =   300
      Left            =   60
      TabIndex        =   1
      Text            =   "Combo1"
      Top             =   2760
      Width           =   1695
   End
   Begin TextBox FileNameText 
      Height          =   315
      Left            =   60
      TabIndex        =   0
      Top             =   420
      Width           =   1695
   End
   Begin Label FileNameLabel 
      Caption         =   "File Name:"
      Height          =   195
      Left            =   60
      TabIndex        =   11
      Top             =   120
      Width           =   1695
   End
   Begin Label DirectoriesLabel 
      Caption         =   "Directories:"
      Height          =   255
      Left            =   1800
      TabIndex        =   10
      Top             =   120
      Width           =   1515
   End
   Begin Label DirectoryPathLabel 
      Caption         =   "C:\some\example\yep"
      Height          =   315
      Left            =   1800
      TabIndex        =   9
      Top             =   420
      Width           =   1935
   End
   Begin Label DrivesLabel 
      Caption         =   "Drives:"
      Height          =   255
      Left            =   1800
      TabIndex        =   8
      Top             =   2460
      Width           =   1935
   End
   Begin Label FileExtensionLabel 
      Caption         =   "File Extension:"
      Height          =   255
      Left            =   60
      TabIndex        =   7
      Top             =   2460
      Width           =   1695
   End
End
Option Explicit

Sub CancelCommand_Click ()
    Unload OpenFileForm
End Sub

Sub DirControl_Change ()
    FileControl.Path = DirControl.Path
    DirectoryPathLabel.Caption = DirControl.Path
End Sub

Sub DriveControl_Change ()
    On Error GoTo ErrorHandler
    DirControl.Path = DriveControl.Drive
    
    Exit Sub

ErrorHandler:   ' Error handler line label.
    Dim msg As String
    msg = "ERROR: An unknown error occured."

    Select Case Err
        Case 53: msg = "ERROR 53: That file doesn't exist."
        Case 68: msg = "ERROR 68: Drive not available."
        Case 76: msg = "ERROR 76: That path doesn't exist."
        Case Else: msg = "ERROR " & Err & " occurred." & NEW_LINE & Error$(Err)
    End Select
    MsgBox msg  ' Display error message.
    Resume Next ' Resume procedure.

End Sub

Sub FileControl_Click ()
    Dim SelectedFileName As String
    SelectedFileName = FileControl.List(FileControl.ListIndex)
    FileNameText.Text = SelectedFileName
End Sub

Sub FileControl_DblClick ()
    OkCommand.Value = True
End Sub

Sub FileExtensionCombo_Click ()
    FileControl.Pattern = FileExtensionCombo.Text
End Sub

Sub FileNameText_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        OkCommand.Value = True
    ElseIf KeyAscii = ESC_KEY Then
        Unload OpenFileForm
    End If

End Sub

Sub Form_Load ()
    DriveControl.Drive = FileControlForm.DriveControl.Drive
    DirControl.Path = FileControlForm.DirControl.Path

    FileExtensionCombo.AddItem DEFAULT_FILE_PATTERN
    FileExtensionCombo.AddItem CBL_FILE_PATTERN
    FileExtensionCombo.AddItem CPY_FILE_PATTERN
    FileExtensionCombo.AddItem BAT_FILE_PATTERN
    FileExtensionCombo.AddItem TXT_FILE_PATTERN
    FileExtensionCombo.AddItem ALL_FILES_PATTERN
    FileExtensionCombo.Text = FileExtensionCombo.List(0)

    FileControl.Pattern = DEFAULT_FILE_PATTERN
    DirectoryPathLabel.Caption = DirControl.Path

End Sub

Sub Form_Unload (Cancel As Integer)
    MainForm.Enabled = True
    FileControlForm.Enabled = True
End Sub

Sub OkCommand_Click ()
    If FileNameText.Text = "" Then
        Exit Sub
    End If

    Dim FileName As String
    Dim Path As String

    FileName = FileNameText.Text
    Path = FileControl.Path

    If Right$(Path, 1) <> "\" Then
        Path = Path + "\"
    End If

    If Not IsDiffFile%(Path, FileName) Then
        'Same file.. don't do anything.
        Exit Sub
    End If

    MainForm.EditorText.Text = GetFileContents$(Path, FileName)
    MainForm.Caption = "NE COBOL Editor - " & LCase$(FileName)

    FileControlForm.FileControl.Path = Path
    FileControlForm.DirControl.Path = Path
    FileControlForm.DriveControl.Drive = DriveControl.Drive
    Unload OpenFileForm

End Sub

