Option Explicit
' Module: State Helper
' Purpose:
'     Handles UI functionality that can be triggered from
'     multiple forms or elements to reduce code
'     duplication.

Sub DeleteSelectedDirectory ()
    Dim PathToDelete As String
    PathToDelete = FileControlForm.DirControl.List(FileControlForm.DirControl.ListIndex)

    If DeleteDirectory(PathToDelete) Then
        If FileControlForm.FileControl.Path = PathToDelete Then
            FileControlForm.DirControl.Path = ".."
        Else
            'stupid way to force refresh
            Dim TempPath As String
            TempPath = FileControlForm.DirControl.Path
            FileControlForm.DirControl.Path = "\"
            FileControlForm.DirControl.Path = TempPath
        End If
    End If
End Sub

Sub DeleteSelectedFile ()
    Dim FileToDelPath As String
    Dim FileToDelName As String

    FileToDelName = FileControlForm.FileControl.List(FileControlForm.FileControl.ListIndex)
    FileToDelPath = FileControlForm.FileControl.Path

    If DeleteFile%(FileToDelPath, FileToDelName) Then
        'stupid way to force directory contents
        'refresh
        FileControlForm.DirControl.Path = "\"
        FileControlForm.DirControl.Path = FileToDelPath
    End If

End Sub

Sub IsFreeFormatMode (IsFreeMode As Integer)
    
    If IsFreeMode Then
        MainForm.FreeFormatMenuItem.Checked = True
        MainForm.CommentFrame.Visible = False
        MainForm.AreaAFrame.Visible = False
        MainForm.AreaBFrame.Visible = False
        MainForm.IdentificationAreaFrame.Visible = False
        MainForm.IdentificationAreaEndFrame.Visible = False
    Else
        Dim FontSize As Single
        FontSize = MainForm.EditorText.FontSize
        If FontSize < 8.25 Or FontSize > 9 Then
            MsgBox "The current font size of " & FontSize & " is not compatible with fixed format area visualizations. Please set font size between 8.25 and 9 in the Fonts option and try again.", MB_ICONEXCLAMATION, "Cannot Change Format Style Visualizations"
            Exit Sub
        End If

        MainForm.FreeFormatMenuItem.Checked = False
        MainForm.CommentFrame.Visible = True
        MainForm.AreaAFrame.Visible = True
        MainForm.AreaBFrame.Visible = True
        MainForm.IdentificationAreaFrame.Visible = True
        MainForm.IdentificationAreaEndFrame.Visible = True
    End If

End Sub

Function IsTabConvertEnabled% ()
    IsTabConvertEnabled% = IS_TAB_CONVERT_ENABLED
End Function

Sub SetTabConvertEnabled (TabConvertEnabled%)
    IS_TAB_CONVERT_ENABLED = TabConvertEnabled%

    MainForm.ConvertTabsDuringSaveMenuItem.Checked = IS_TAB_CONVERT_ENABLED
End Sub

Sub ToggleFileControls ()
    Dim IsVisible As Integer
    IsVisible = Not FileControlForm.Visible
    
    FileControlForm.Visible = IsVisible
    MainForm.ShowFileControlsMenuOption.Checked = IsVisible
    MainForm.DirectoryMenu.Enabled = IsVisible
    MainForm.DeleteFileMenuItem.Enabled = IsVisible
End Sub

